"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tape_1 = __importDefault(require("tape"));
const _1 = __importDefault(require("."));
const memory_1 = __importDefault(require("./store/memory"));
const file_1 = __importDefault(require("./store/file"));
const password = 'password';
const key = 'test';
const value = { foo: 'bar' };
const tests = (t, store) => {
    const vault = new _1.default(store);
    t.test('write to vault', (tt) => {
        tt.plan(1);
        vault.set(key, value, password);
        tt.pass();
    });
    t.test('read from vault', (tt) => {
        tt.plan(3);
        const res = vault.get(key, password);
        tt.pass();
        tt.equal(typeof res, 'object');
        tt.equal(res.foo, value.foo);
    });
    t.test('get all keys', (tt) => {
        tt.plan(2);
        const res = vault.keys();
        tt.pass();
        tt.deepEqual(res, [key]);
    });
};
tape_1.default('create vault memory', (t) => __awaiter(void 0, void 0, void 0, function* () {
    tests(t, new memory_1.default());
}));
tape_1.default('create vault file', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const path = __dirname + '/test.json';
    tests(t, new file_1.default(path));
}));
