"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
class File {
    constructor(path) {
        this._path = path;
        fs_1.mkdirSync(path_1.dirname(path_1.resolve(this._path)), { recursive: true });
    }
    set(key, value) {
        const data = this.loadStore();
        data[key] = value;
        fs_1.writeFileSync(this._path, JSON.stringify(data));
    }
    get(key) {
        return this.loadStore()[key];
    }
    keys() {
        return Object.keys(this.loadStore());
    }
    loadStore() {
        return fs_1.existsSync(this._path)
            ? JSON.parse(fs_1.readFileSync(this._path).toString())
            : {};
    }
}
exports.default = File;
